> ## Documentation Index
> Fetch the complete documentation index at: https://rollout.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Custom Field

> Requires `customFields: true` in the credential's `entitiesToSync` selection and a connector that supports this operation. [Choose what data to sync](https://rollout.com/docs/advanced-guides/controlling-which-records-sync-with-rollout), or [fix an entity that is not configured to sync](https://rollout.com/docs/troubleshooting/entity-not-configured-to-sync).



## OpenAPI

````yaml /openapi/mortgage-crm.json post /customFields
openapi: 3.1.2
info:
  title: Universal Mortgage CRM API Documentation
  description: Development documentation
  version: '1.0'
servers:
  - url: https://mortgage-crm.universal.rollout.com/api
security: []
paths:
  /customFields:
    post:
      tags:
        - Custom Fields
      summary: Create Custom Field
      description: >-
        Requires `customFields: true` in the credential's `entitiesToSync`
        selection and a connector that supports this operation. [Choose what
        data to
        sync](https://rollout.com/docs/advanced-guides/controlling-which-records-sync-with-rollout),
        or [fix an entity that is not configured to
        sync](https://rollout.com/docs/troubleshooting/entity-not-configured-to-sync).
      operationId: postCustomFields
      requestBody:
        required: true
        content:
          application/json:
            schema:
              anyOf:
                - type: object
                  properties:
                    type:
                      type: string
                      const: text
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: date
                    label:
                      type: string
                    isRecurring:
                      type: boolean
                    name:
                      type: string
                  required:
                    - type
                    - label
                    - isRecurring
                - type: object
                  properties:
                    type:
                      type: string
                      const: number
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: boolean
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: dropdown
                    label:
                      type: string
                    choices:
                      type: array
                      items:
                        type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                    - choices
          application/x-www-form-urlencoded:
            schema:
              anyOf:
                - type: object
                  properties:
                    type:
                      type: string
                      const: text
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: date
                    label:
                      type: string
                    isRecurring:
                      type: boolean
                    name:
                      type: string
                  required:
                    - type
                    - label
                    - isRecurring
                - type: object
                  properties:
                    type:
                      type: string
                      const: number
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: boolean
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: dropdown
                    label:
                      type: string
                    choices:
                      type: array
                      items:
                        type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                    - choices
          multipart/form-data:
            schema:
              anyOf:
                - type: object
                  properties:
                    type:
                      type: string
                      const: text
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: date
                    label:
                      type: string
                    isRecurring:
                      type: boolean
                    name:
                      type: string
                  required:
                    - type
                    - label
                    - isRecurring
                - type: object
                  properties:
                    type:
                      type: string
                      const: number
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: boolean
                    label:
                      type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                - type: object
                  properties:
                    type:
                      type: string
                      const: dropdown
                    label:
                      type: string
                    choices:
                      type: array
                      items:
                        type: string
                    name:
                      type: string
                  required:
                    - type
                    - label
                    - choices
      responses:
        '201':
          description: The created custom field.
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      type:
                        type: string
                        const: text
                      id:
                        type: string
                      label:
                        type: string
                      name:
                        type:
                          - string
                          - 'null'
                      key:
                        description: >-
                          The upstream's own identifier for the field, exactly
                          as the upstream spells it, and the key its values have
                          in a person's `customFields` object. null when the
                          connector's people still carry custom fields as
                          `custom<Name>` properties.
                        type:
                          - string
                          - 'null'
                      originalIds:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type:
                            - number
                            - string
                      original:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type: object
                          propertyNames:
                            type: string
                          additionalProperties: {}
                    required:
                      - type
                      - id
                      - label
                      - name
                      - key
                      - originalIds
                      - original
                  - type: object
                    properties:
                      type:
                        type: string
                        const: date
                      id:
                        type: string
                      label:
                        type: string
                      name:
                        type:
                          - string
                          - 'null'
                      key:
                        description: >-
                          The upstream's own identifier for the field, exactly
                          as the upstream spells it, and the key its values have
                          in a person's `customFields` object. null when the
                          connector's people still carry custom fields as
                          `custom<Name>` properties.
                        type:
                          - string
                          - 'null'
                      isRecurring:
                        type: boolean
                      originalIds:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type:
                            - number
                            - string
                      original:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type: object
                          propertyNames:
                            type: string
                          additionalProperties: {}
                    required:
                      - type
                      - id
                      - label
                      - name
                      - key
                      - isRecurring
                      - originalIds
                      - original
                  - type: object
                    properties:
                      type:
                        type: string
                        const: number
                      id:
                        type: string
                      label:
                        type: string
                      name:
                        type:
                          - string
                          - 'null'
                      key:
                        description: >-
                          The upstream's own identifier for the field, exactly
                          as the upstream spells it, and the key its values have
                          in a person's `customFields` object. null when the
                          connector's people still carry custom fields as
                          `custom<Name>` properties.
                        type:
                          - string
                          - 'null'
                      originalIds:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type:
                            - number
                            - string
                      original:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type: object
                          propertyNames:
                            type: string
                          additionalProperties: {}
                    required:
                      - type
                      - id
                      - label
                      - name
                      - key
                      - originalIds
                      - original
                  - type: object
                    properties:
                      type:
                        type: string
                        const: boolean
                      id:
                        type: string
                      label:
                        type: string
                      name:
                        type:
                          - string
                          - 'null'
                      key:
                        description: >-
                          The upstream's own identifier for the field, exactly
                          as the upstream spells it, and the key its values have
                          in a person's `customFields` object. null when the
                          connector's people still carry custom fields as
                          `custom<Name>` properties.
                        type:
                          - string
                          - 'null'
                      originalIds:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type:
                            - number
                            - string
                      original:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type: object
                          propertyNames:
                            type: string
                          additionalProperties: {}
                    required:
                      - type
                      - id
                      - label
                      - name
                      - key
                      - originalIds
                      - original
                  - type: object
                    properties:
                      type:
                        type: string
                        const: dropdown
                      id:
                        type: string
                      label:
                        type: string
                      name:
                        type:
                          - string
                          - 'null'
                      key:
                        description: >-
                          The upstream's own identifier for the field, exactly
                          as the upstream spells it, and the key its values have
                          in a person's `customFields` object. null when the
                          connector's people still carry custom fields as
                          `custom<Name>` properties.
                        type:
                          - string
                          - 'null'
                      choices:
                        type: array
                        items:
                          type: string
                      originalIds:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type:
                            - number
                            - string
                      original:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties:
                          type: object
                          propertyNames:
                            type: string
                          additionalProperties: {}
                    required:
                      - type
                      - id
                      - label
                      - name
                      - key
                      - choices
                      - originalIds
                      - original
                description: The created custom field.
        '400':
          description: Response for status 400
          content:
            application/json:
              schema:
                type: object
                properties:
                  errorMessage:
                    type: string
                required:
                  - errorMessage
        '423':
          description: >-
            423 Locked — the credential is temporarily frozen by an operator.
            Reads still work; POST/PATCH/PUT/DELETE are rejected until it is
            unfrozen. Unlike 424 (invalid credential), do not re-authenticate —
            retry later.
          content:
            application/json:
              schema:
                type: object
                properties:
                  errors:
                    type: array
                    items:
                      type: object
                      properties:
                        message:
                          type: string
                      required:
                        - message
                required:
                  - errors
      security:
        - jwt: []
          credential_id: []
components:
  securitySchemes:
    jwt:
      type: http
      scheme: bearer
      description: Consumer JWT minted by the tenant's backend
    credential_id:
      type: apiKey
      in: header
      name: X-Rollout-Credential-Id
      description: The Rollout Credential ID to use for queries/mutations

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.